GNU Radio's TEST Package

Public Member Functions | List of all members
moodycamel::weak_atomic< T > Class Template Reference

`#include <atomicops.h>`

## Public Member Functions
| weak_atomic ()
template<typename U >
| weak_atomic (U &&x)
| weak_atomic (weak_atomic const &other)
| weak_atomic (weak_atomic &&other)
AE_FORCEINLINE | operator T () const
template<typename U >
AE_FORCEINLINE weak_atomic const & | operator= (U &&x)
AE_FORCEINLINE weak_atomic const & | operator= (weak_atomic const &other)
AE_FORCEINLINE T | load () const
AE_FORCEINLINE T | fetch_add_acquire (T increment)
AE_FORCEINLINE T | fetch_add_release (T increment)

## Constructor & Destructor Documentation

## ◆ weak_atomic() [1/4]

template<typename T >

moodycamel::weak_atomic< T >::weak_atomic | ( |  | ) |
| inline

## ◆ weak_atomic() [2/4]

template<typename T >
template<typename U >

moodycamel::weak_atomic< T >::weak_atomic | ( | U && | x | ) |
| inline

## ◆ weak_atomic() [3/4]

template<typename T >

moodycamel::weak_atomic< T >::weak_atomic | ( | weak_atomic< T > const & | other | ) |
| inline

## ◆ weak_atomic() [4/4]

template<typename T >

moodycamel::weak_atomic< T >::weak_atomic | ( | weak_atomic< T > && | other | ) |
| inline

## Member Function Documentation

## ◆ fetch_add_acquire()

template<typename T >

AE_FORCEINLINE T moodycamel::weak_atomic< T >::fetch_add_acquire | ( | T | increment | ) |
| inline

References moodycamel::memory_order_acquire.

Referenced by moodycamel::spsc_sema::LightweightSemaphore::tryWait().

## ◆ fetch_add_release()

template<typename T >

AE_FORCEINLINE T moodycamel::weak_atomic< T >::fetch_add_release | ( | T | increment | ) |
| inline

References moodycamel::memory_order_release.

Referenced by moodycamel::spsc_sema::LightweightSemaphore::signal().

## ◆ load()

template<typename T >

AE_FORCEINLINE T moodycamel::weak_atomic< T >::load | ( |  | ) | const
| inline

References moodycamel::memory_order_relaxed.

Referenced by moodycamel::spsc_sema::LightweightSemaphore::availableApprox(), moodycamel::weak_atomic< Block * >::operator Block *(), moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::peek(), moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::pop(), moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::size_approx(), moodycamel::ReaderWriterQueue< T, MAX_BLOCK_SIZE >::try_dequeue(), and moodycamel::spsc_sema::LightweightSemaphore::tryWait().

## ◆ operator T()

template<typename T >

AE_FORCEINLINE moodycamel::weak_atomic< T >::operator T | ( |  | ) | const
| inline

## ◆ operator=() [1/2]

template<typename T >
template<typename U >

AE_FORCEINLINE weak_atomic const & moodycamel::weak_atomic< T >::operator= | ( | U && | x | ) |
| inline

References moodycamel::memory_order_relaxed.

## ◆ operator=() [2/2]

template<typename T >

AE_FORCEINLINE weak_atomic const & moodycamel::weak_atomic< T >::operator= | ( | weak_atomic< T > const & | other | ) |
| inline

References moodycamel::memory_order_relaxed.

The documentation for this class was generated from the following file:

- atomicops.h